---
apiVersion: infrastructure.cluster.x-k8s.io/v1beta1
kind: OpenStackMachineTemplate
metadata:
  name: {{ capi_cluster }}-control-plane # SPEC HASH SUFFIX ADDED DURING RENDERING
  namespace: {{ capi_kube_namespace }}
  labels:
    capi.skao.int/cluster: {{ capi_cluster }}
    capi.skao.int/component: control-plane
spec:
  template:
    spec:
      flavor: {{ capi_capo_controlplane_machine_flavour }}
      identityRef:
        name: {{ capi_cluster }}-cloud-config
        cloudName: {{ capi_capo_openstack_cloud }}
      image:
        filter:
          name: {{ capi_capo_openstack_image_name }}
      ports:
      # set to true if using MetalLB: https://metallb.universe.tf/installation/clouds/#metallb-on-openstack
      - disablePortSecurity: {{ capi_capo_openstack_disable_port_security | lower }}
        network:
          filter:
            name: {{ capi_capo_openstack_network_name }}
{% if not capi_capo_openstack_disable_port_security %}
      securityGroups: {{ capi_capo_openstack_security_groups | default([]) | to_json }}
{% endif %}
      sshKeyName: {{ capi_capo_openstack_ssh_key_name }}
---
apiVersion: controlplane.cluster.x-k8s.io/v1beta1
kind: KubeadmControlPlane
metadata:
  name: {{ capi_cluster }}-control-plane
  namespace: {{ capi_kube_namespace }}
  labels:
    capi.skao.int/cluster: {{ capi_cluster }}
    capi.skao.int/collections-branch: {{ capi_collections_branch }}
    capi.skao.int/component: control-plane
spec:
  version: v{{ capi_k8s_version }}
  replicas: {{ capi_controlplane_count }}
  machineTemplate:
    infrastructureRef:
      apiVersion: infrastructure.cluster.x-k8s.io/v1beta1
      kind: OpenStackMachineTemplate
      name: {{ capi_cluster }}-control-plane # SPEC HASH SUFFIX ADDED DURING RENDERING
  kubeadmConfigSpec:
    clusterConfiguration:
      apiServer:
        certSANs: {{ (capi_apiserver_extra_sans | default([])) | unique | to_json }}
        extraArgs:
          cloud-provider: external
        extraVolumes: []
{% if not capi_capo_openstack_enable_apiserver_lb %}
      controlPlaneEndpoint: {{ capi_capo_openstack_ext_apiserver_ip }}:{{ capi_capo_openstack_ext_apiserver_port }}
{% endif %}
      controllerManager:
        extraArgs:
          bind-address: 0.0.0.0
          cloud-provider: external
        extraVolumes: []
      dns:
        imageRepository: {{ capi_dns_image_name }}
        imageTag: {{ capi_dns_image_tag }}
      etcd:
        local:
          extraArgs: {{ capi_etcd_args | to_json }}
      imageRepository: registry.k8s.io
      scheduler:
        extraArgs:
          bind-address: 0.0.0.0
    verbosity: 5
    files:
    - path: /etc/kubernetes/clouds.yaml
      content: {{ capi_capo_openstack_cloud_yaml_b64 }}
      encoding: base64
      owner: root
      permissions: "0600"
    - path: /etc/certs/cacert
      content: {{ capi_capo_cacert_b64 }}
      encoding: base64
      owner: root
      permissions: "0600"
    - path: /etc/kubernetes/initialise-install-tools.sh
      content: |
        #!/usr/bin/bash
        echo ""
        echo "==================================================================="
        echo "preKubeadmCommands: initialise $(date)"
        set -x

        apt update
        apt install -y --allow-change-held-packages gettext-base git ca-certificates net-tools python3-pip
        pip3 install ansible kubernetes

        cd /usr/src && \
        git clone https://gitlab.com/ska-telescope/sdi/ska-ser-ansible-collections.git --recurse-submodules && \
        cd ska-ser-ansible-collections && \
        git checkout {{ capi_collections_branch }} && \
        git submodule update --init --recursive

        cat <<EOF > run-play.sh
        #!/usr/bin/bash
        echo "run-play.sh args are: \$*"
        cd /usr/src/ska-ser-ansible-collections
        export ANSIBLE_COLLECTIONS_PATHS="/usr/src/ska-ser-ansible-collections:$HOME/.ansible/collections:/usr/share/ansible/collections"
        export KUBECONFIG="/etc/kubernetes/admin.conf"
        export ANSIBLE_CONFIG="/usr/src/ska-ser-ansible-collections/datacentres/production/installation/ansible.cfg"
        ansible-playbook \
          --connection=local \
          --limit localhost \
          --become \
          --extra-vars "ansible_user=ubuntu" \
          --extra-vars "common_dns_servers=\"{{ capi_dns_servers | join(' ') }}\"" \
          --extra-vars "docker_allow_version_change=true" \
          --extra-vars "docker_mtu={{ capi_docker_mtu }}" \
          --extra-vars "docker_activate_nvidia={{ context.nvidia_enabled | default(false) | lower }}" \
          --extra-vars "containerd_activate_nvidia={{ context.nvidia_enabled | default(false) | lower }}" \
          --extra-vars "{{ capi_oci_mirror_type }}={{ capi_oci_mirror_ip }}" \
          --extra-vars "harbor_local_domain={{ capi_oci_mirror_local_domain }}" \
          --extra-vars "harbor_port={{ capi_oci_mirror_port }}" \
          --extra-vars "capi_cluster={{ capi_cluster }}" \
          --extra-vars "k8s_kubeconfig=/etc/kubernetes/admin.conf" \
          --extra-vars "k8s_kubernetes_version={{ capi_k8s_version }}" \
{% for key,value in (context.init_extra_vars | default({})).items()  %}
          --extra-vars "{{ key }}={{ value }}" \
{% endfor %}
          /usr/src/ska-ser-ansible-collections/ansible_collections/ska_collections/clusterapi/playbooks/\$1 \${@:2}
        EOF

        chmod a+x run-play.sh
        cat run-play.sh

        echo "Finished."
        exit 0
      owner: root:root
    - path: /etc/kubernetes/kubeadm-pre.sh
      content: |
        #!/usr/bin/bash
        echo ""
        echo "==================================================================="
        echo "preKubeadmCommands: deploy $(date)"
        set -x

        if [ "{{ context.nvidia_enabled | default(false) | lower }}" = "true" ]; then
          ansible-galaxy role install \
            -r /usr/src/ska-ser-ansible-collections/requirements.yml \
            --force \
            -p /usr/share/ansible/roles
          /usr/src/ska-ser-ansible-collections/run-play.sh nvidia.yml -vv \
            --extra-vars "nvidia_driver_branch={{ context.nvidia_driver_version | default(capi_nvidia_driver_version) }}" \
            --extra-vars "nvidia_driver_skip_reboot=true"
        fi

        /usr/src/ska-ser-ansible-collections/run-play.sh containerd.yml -vv
        /usr/src/ska-ser-ansible-collections/run-play.sh docker.yml -vv
        if [ "{{ context.oci_image_cleanup_enabled | default(true) | lower }}" = "true" ]; then
          /usr/src/ska-ser-ansible-collections/run-play.sh oci_image_cleanup_cron.yml -vv
        fi
        /usr/src/ska-ser-ansible-collections/run-play.sh ntp.yml -vv
        /usr/src/ska-ser-ansible-collections/run-play.sh dns.yml -vv
        /usr/src/ska-ser-ansible-collections/run-play.sh node-exporter.yml -vv

        if [ "{{ capi_capo_run_kubelet_install | lower }}" = "true" ]; then
          /usr/src/ska-ser-ansible-collections/run-play.sh k8s-setup.yml -vv
        fi

        /usr/src/ska-ser-ansible-collections/run-play.sh install-tools.yml --tags helm -vv

        echo "preKubeadmCommands: end $(date)"
        exit 0
      owner: root:root
    - path: /etc/kubernetes/kubeadm-post.sh
      content: |
        #!/usr/bin/bash

        echo ""
        echo "==================================================================="
        echo "controlplane postKubeadmCommands: start $(date)"

        export KUBECONFIG=/etc/kubernetes/admin.conf
        if [ -f "/etc/kubernetes/super-admin.conf" ]; then
            export KUBECONFIG=/etc/kubernetes/super-admin.conf
        fi

        export CLUSTER_NAME={{ capi_cluster }}
        export OPENSTACK_CLOUD={{ capi_capo_openstack_cloud }}

        set -x

        # check if we are running on one of the other nodes
        MAP=`kubectl -n kube-system get configmap clusterapi-post-run -o yaml`
        rc=$?
        if [[ $rc -eq 0 ]]; then
          echo "clusterapi post kubedm job already running:"
          echo $MAP
          exit
        fi

        iface=`route | grep '^default'  | grep -o '[^ ]*$'`
        ip=`ip a show $iface | grep ' inet ' | awk '{print $2}'`
        kubectl -n kube-system create configmap clusterapi-post-run \
         --from-literal=on-host=$(hostname) \
         --from-literal=ip=$ip

        echo "Running the cluster initialisation: deploy calico"
        /usr/src/ska-ser-ansible-collections/run-play.sh calico-install.yml \
          --extra-vars "k8s_kubeconfig=${KUBECONFIG}" \
          --extra-vars "calico_version={{ capi_calico_version }}" \
{% if capi_calico_tigera_operator_version %}
          --extra-vars "calico_tigera_operator_version={{ capi_calico_tigera_operator_version }}" \
{% endif %}
          --extra-vars "calico_ipv4pool_cidr={{ capi_cidr_block }}" \
          --extra-vars "calico_ipv4pool_ipip={{ capi_calico_ipv4pool_ipip }}" \
          --extra-vars "calico_ip_autodetection_method={{ capi_calico_ip_autodetection_method }}" \
          -vv

        echo "Controlplane initialise: cloud provider config"
        /usr/src/ska-ser-ansible-collections/run-play.sh ../../k8s/playbooks/cloudprovider.yml \
          --extra-vars "k8s_kubeconfig=${KUBECONFIG}" \
          --extra-vars "capi_cluster={{ capi_cluster }}" \
          --extra-vars "k8s_cloudprovider_chart_version={{ capi_cloudprovider_chart_version }}" \
          --extra-vars "k8s_cloudprovider_enable_service_controller={{ capi_capo_openstack_enable_service_lbs | lower }}" \
          --extra-vars "capi_capo_openstack_cloud_config=/etc/kubernetes/clouds.yaml" \
          --extra-vars "capi_capo_openstack_cloud={{ capi_capo_openstack_cloud }}" \
          --tags "cloudprovider" \
          -vv

        echo "postKubeadmCommands: end $(date)"
        exit 0
      owner: root:root
    initConfiguration:
      nodeRegistration:
        name: '{{ '{{ local_hostname }}' }}'
        ignorePreflightErrors: {{ capi_ignore_preflight_errors | to_json }}
        kubeletExtraArgs: {{ capi_cp_kubelet_args | to_kubelet_args }}
    joinConfiguration:
      nodeRegistration:
        name: '{{ '{{ local_hostname }}' }}'
        ignorePreflightErrors: {{ capi_ignore_preflight_errors | to_json }}
        kubeletExtraArgs: {{ capi_cp_kubelet_args | to_kubelet_args }}
    preKubeadmCommands:
      - 'echo "controlplane preKubeadmCommands: start $(date)" >>/tmp/capo-config.log'
      - /usr/bin/bash /etc/kubernetes/initialise-install-tools.sh >>/tmp/capo-config.log 2>&1
      - /usr/bin/bash /etc/kubernetes/kubeadm-pre.sh >>/tmp/capo-config.log 2>&1
    postKubeadmCommands:
      - 'echo "controlplane postKubeadmCommands: start $(date)" >>/tmp/capo-config.log'
      - /usr/bin/bash /etc/kubernetes/kubeadm-post.sh >>/tmp/capo-config.log 2>&1
---
